zoj 3888 Twelves Monkeys 二分+线段树维护次小值

链接:http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemCode=3888

Twelves Monkeys


Time Limit: 5 Seconds      Memory Limit: 32768 KB



James Cole is a convicted criminal living beneath a post-apocalyptic Philadelphia. Many years ago, the Earth‘s surface had been contaminated by a virus so deadly that it forced
the survivors to move underground. In the years that followed, scientists had engineered an imprecise form of time travel. To earn a pardon, Cole allows scientists to send him on dangerous missions to the past to collect information on the virus,
thought to have been released by a terrorist organization known as the Army of the Twelve Monkeys.

The time travel is powerful so that sicentists can send Cole from year x[i] back to year y[i]. Eventually, Cole finds that Goines is the founder
of the Army of the Twelve Monkeys, and set out in search of him. When they find and confront him, however, Goines denies any involvement with the viruscan. After that, Cole goes back and tells scientists what he knew. He wants to quit the mission
to enjoy life. He wants to go back to the any year before current year, but scientists only allow him to use time travel once. In case of failure, Cole will find at least one route for backup. Please help him to calculate how many years he can go
with at least two routes.

Input

The input file contains multiple test cases.

The first line contains three integers n,m,q(1≤ n ≤ 50000, 1≤ m ≤ 50000, 1≤ q ≤ 50000), indicating the maximum year,
the number of time travel path and the number of queries.

The following m lines contains two integers x,y(1≤ y  x ≤ 50000) indicating Cole can travel from year x to
year y.

The following q lines contains one integers p(1≤ p ≤ n) indicating the year Cole is at now

Output

For each test case, you should output one line, contain a number which is the total number of the year Cole can go.

Sample Input

9 3 3
9 1
6 1
4 1
6
7
2

Sample Output

5
0
1

Hint

6 can go back to 1 for two route. One is 6-1, the other is 6-7-8-9-1. 6 can go back to 2 for two route. One is 6-1-2, the other is 6-7-8-9-1-2.

题意:

有m个可以穿越回过去的机器,但是只能用一个,还有q个询问。

输出,当在p点时, 1到p-1  这些点有多少点可以通过两种方式穿越回去。

做法:

首先要穿越,必须要机器的r 大于等于p。这个是二分排序后去找的。

然后用线段树找出这些r大于等于p的机器的l的次小值。

很明显 次小l 后的所有点都可以用  最小l的机器,和次小l的机器 穿越回那些点。

所以 点的总数是  max(p-l,0)。

数据有问题有m==0 的输入,所以多次SF了,所以加了 m==0的特判。

也可以按n来建树就不存在这个问题了。

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <malloc.h>
#include <ctype.h>
#include <math.h>
#include <string>
#include <iostream>
#include <algorithm>
#include <set>
using namespace std;

struct point
{
	int l,r;
	bool operator <(const point &b)const
	{
		return r<b.r;
	}
};
 point pp[50111]; 

#define lson l , m , rt << 1
#define rson m + 1 , r , rt << 1 | 1
#define LL int
#define inf 1000000
const int maxn = 50010;
pair<int,int> max2(pair<int,int> a,pair<int,int> b)
{
	pair<int,int> tem;
	if(a.first==b.first)
	{
		tem.first=tem.second=a.first;
	}
	else if(a.first>b.first)
	{
		tem.first=b.first;
		tem.second=min(a.first,b.second);
	}
	else if(a.first<b.first)
	{
		tem.first=a.first;
		tem.second=min(b.first,a.second);
	}

	return tem;
}

pair<int,int>  big[maxn<<2];
void PushUp(int rt) {
	big[rt] = max2(big[rt<<1] ,big[rt<<1|1]);
}
int kk;
void build(int l,int r,int rt) {
	big[rt].second=inf;
	if (l == r) {
		big[rt].first=pp[kk++].l;
		return ;
	}
	int m = (l + r) >> 1;
	build(lson);
	build(rson);
	PushUp(rt);
} 

pair<int,int> query(int L,int R,int l,int r,int rt) {
	if (L <= l && r <= R) {
		return  big[rt];
	}

	int m = (l + r) >> 1;

	if(L<=m&&m<R)
		return max2(query(L , R , lson),query(L , R , rson));
	if (L <= m)
		return query(L , R , lson);
	if (m < R)
		return query(L , R , rson);
}

int cmp(point a,point b)
{
	return a.r<b.r;
}

int main()
{
	int i,a,b;
	int m,q;
	int n;
	while(scanf("%d%d%d",&n,&m,&q)!=EOF)
	{
		//if(m==0) 加了就超时 感觉有m==0的案例
			//while(1);
		kk=1;
		int ge=0;
		for(i=1;i<=m;i++)
			scanf("%d%d",&pp[i].r,&pp[i].l);
		sort(pp+1,pp+m+1);
		if(m)//之前m等于0 也建树 被坑死了
		build(1,m,1); 

		while(q--)
		{
			int p;
			scanf("%d",&p); 

			if(!m)
			{
				puts("0");
				continue;
			}
			point tt;
			tt.r=p;
			int wei=lower_bound(pp+1,pp+m+1,tt)-pp;
			if(wei==m+1)//找不到
			{
				puts("0");
				continue;
			}
			pair<int,int> tem,t2;
			tem=query(wei,m,1,m,1);
			if(tem.second==inf)
				puts("0");
			else
				printf("%d\n",max(0,p-tem.second));
		}
	}
	return 0;
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-10-27 13:52:34

zoj 3888 Twelves Monkeys 二分+线段树维护次小值的相关文章

ZOJ 3888 Twelves Monkeys (预处理+优先队列)

题目链接:ZOJ 3888 Twelves Monkeys 题意:题目描写叙述起来比較绕,直接讲案例 9 3 3 9 1 6 1 4 1 6 7 2 输入n,m,q.n限制了你询问的年份,m台时光机,q个询问. 接下来m行,描写叙述从第9年回到第1年. 接下里就是三个询问. 第一个询问6的答案是5. 1.从第6年回到第1年 (6-1)直接做时光机2,(6-7-8-9-1)过3年之后能够做时光机3. 有两个路径能够走(题目中要求至少两条路径).所以是有效的方案. 2.从第6年回到第2年 .....

CF213E Two Permutations 线段树维护哈希值

当初竟然看成子串了$qwq$,不过老师的$ppt$也错了$qwq$ 由于子序列一定是的排列,所以考虑插入$1$到$m$到$n-m+1$到$n$; 如何判断呢?可以用哈希$qwq$: 我们用线段树维护哈希值,合并时用就把左子树的哈希值$x[ls]$在$B$进制下左移$sum[rs]$位,即$x[tr]=x[ls]*p[sum[rs]]+x[rs]$; 此时就可以向上更新哈希值. #include<cstdio> #include<iostream> #include<algor

最敏捷的机器人(线段树维护区间最值)

题面: Wind设计了很多机器人.但是它们都认为自己是最强的,于是,一场比赛开始了--机器人们都想知道谁是最敏捷的,于是它们进行了如下一个比赛.首先,他们面前会有一排共n个数,它们比赛看谁能最先把每连续k个数中最大和最小值写下来,当然,这些机器人运算速度都很,它们比赛的是谁写得快.但是Wind也想知道答案,你能帮助他吗? Input: 每组测试数据 第1行为n,k(1<=k<=n<=100000) 第2行共n个数,为数字序列,所有数字均在int范围内. Output: 共n-k+1行 第

zoj 3888 Twelves Monkeys(zoj 2015年7月月赛)

Twelves Monkeys Time Limit: 5 Seconds      Memory Limit: 32768 KB James Cole is a convicted criminal living beneath a post-apocalyptic Philadelphia. Many years ago, the Earth's surface had been contaminated by a virus so deadly that it forced the sur

HDU - 4614 【二分+线段树维护】

Vases and Flowers Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 65535/32768 K (Java/Others)Total Submission(s): 3263    Accepted Submission(s): 1299 Problem Description Alice is so popular that she can receive many flowers everyday. She has

Codeforces 460C 二分结果+线段树维护

发现最近碰到好多次二分结果的题目,上次多校也是,被我很机智的快速过了,这个思想确实非常不错.在正面求比较难处理的时候,二分结果再判断是否有效往往柳暗花明. 这个题目给定n个数字的序列,可以操作m次,每次要操作w个连续的数字,每次的操作将使得该段连续数字的数都+1,最后求整个序列最小值的最大值 求最小值最大,明显的二分结果的题目,我一开始还是在ACdream那个群里看到这个题,说是二分+线段树的题目,我就来做了一下..首先二分部分很容易,下界就是初始序列的最小值,上界就是 下界+m,至于怎么判断这

BZOJ 2402 陶陶的难题II 二分答案+斜率优化+树链剖分+线段树维护凸包

题目大意:给定一棵树,每个点有两个坐标(x1,y1)和(x2,y2),多次询问某条链上选择两个点i和j(可以相同),求(y1i+y2j)/(x1i+x2j)的最大值 我竟没看出来这是01分数规划...真是老了... 二分答案ans,问题转化成验证(y1i+y2j)/(x1i+x2j)是否>=ans 将式子变形可得(y1i-ans*x1i)+(y2j-ans*x2j)>=0 加号两边独立,分别计算即可 问题转化为求链上y-ans*x最大的点 令P=y-ans*x 则y=ans*x+P 我们发现这

计蒜客16492 building(二分线段树/分块)

题解: 考虑用线段树维护楼的最大值,然后这个问题就很简单了. 每次可以向左二分出比x高的第一个楼a,同理也可以向右二分出另一个楼b,如果a,b都存在,答案就是b-a-1. 注意到二分是可以直接在线段树上进行的,所以复杂度是O(nlogn). 当然这里是用分块做的,更暴力一些. #include <iostream> #include <cstdio> #include <cstring> #include <cmath> using namespace st

51nod1287(二分/线段树区间最值&amp;单点更新)

题目链接:http://www.51nod.com/onlineJudge/questionCode.html#!problemId=1287 题意:中文题诶- 解法1:b[i] 存储 max(a[0], ....., a[i]),显然 b 是单调不减的,所以直接二分 x,再更新 a 和 b 数组即可: 代码: 1 #include <iostream> 2 #include <stdio.h> 3 using namespace std; 4 5 const int MAXN =